 /*
  * Khoros: $Id: Pipe.h,v 1.3 1992/03/20 23:38:01 dkhoros Exp $
  */

 /*
  * $Log: Pipe.h,v $
 * Revision 1.3  1992/03/20  23:38:01  dkhoros
 * VirtualPatch5
 *
  */ 


/*
 *----------------------------------------------------------------------
 *
 * Copyright 1990, University of New Mexico.  All rights reserved.

 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"	 /* Copyright 1990 by UNM */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>								<<<<
   >>>>	    file name: Pipe.h					<<<<
   >>>>								<<<<
   >>>>   description:						<<<<
   >>>>								<<<<
   >>>> modifications:						<<<<
   >>>>								<<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */


#ifndef _Pipe_h_
#define _Pipe_h_


/*
 *  Internal structures for the following transport
 *
 *		pipe	   -  Pipe transport
 */

/* pipe structure */
typedef struct
{
	int	fid[2];
} PipeStruct;

#undef  ResourceStruct
#define ResourceStruct PipeStruct


int	pipe_tempnam(),
	pipe_open(),
	pipe_close(),
	pipe_read(),
	pipe_write(),
	pipe_lseek(),
	pipe_tell(),
	pipe_unlink(),
	pipe_lock(),
	pipe_descriptors();

static TransportInformation pipe_routines[] =
{
    {
	"Standard Unix Pipe",
	"pipe",
	FALSE,
	pipe_tempnam,
	pipe_open,
	pipe_close,
	pipe_read,
	pipe_write,
	pipe_lseek,
	pipe_tell,
	NULL,
	pipe_unlink,
	pipe_lock,
	pipe_descriptors,

	NULL,
    }
};

#endif /* _Pipe_h_ */
/* don`t add after the endif */
